#ifndef BIRTHDAYDYNAMIC_H_
#define BIRTHDAYDYNAMIC_H_

#include "Birthday.h"

class BirthdayDynamic
{
public:
    BirthdayDynamic(int len) : length(len), elements(new Birthday[len]) {}

    virtual ~BirthdayDynamic()
    {
        if (elements != nullptr) delete[] elements;
    }

    BirthdayDynamic(const BirthdayDynamic& other)
        : length(other.length), elements(new Birthday[length])
    {
        // Copy the elements.
        for (int i = 0; i < length; i++) elements[i] = other[i];
    }

    int get_length() const { return length; }

    // Overloaded [] subscript operator.
    Birthday& operator [](const int index) const
    {
        return elements[index];  // should check the index first
    }

private:
    int length;
    Birthday *elements;
};

#endif /* BIRTHDAYDYNAMIC_H_ */
